leetcode 1 Two Sum

来源:互联网 发布:化妆品销售数据分析 编辑:程序博客网 时间:2024/06/10 11:25

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:

Given nums = [2, 7, 11, 15], target = 9,Because nums[0] + nums[1] = 2 + 7 = 9,return [0, 1].

解:暴力搜索都会,这里用依次遍历的方法,如何快捷的找到所要的数是否在数组中呢,hash是一个不错的选择

代码:

class Solution {public:    vector<int> twoSum(vector<int>& nums, int target) {        vector<int> res;        map<int, int> hashMap;        for(int i = 0; i < nums.size(); i++){            int others = target - nums[i];            if(hashMap.find(others) != hashMap.end()){                res.push_back(hashMap[others]);                res.push_back(i);                return res;            }            hashMap[nums[i]] = i;        }    }};
Run Code Result: